VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmProperties 
   Caption         =   "WUhr - Eigenschaften"
   ClientHeight    =   2175
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4815
   LinkTopic       =   "Form1"
   ScaleHeight     =   2175
   ScaleWidth      =   4815
   StartUpPosition =   3  'Windows-Standard
   Begin MSComDlg.CommonDialog comDialog 
      Left            =   2400
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
   End
   Begin VB.CommandButton cmdColSec 
      Caption         =   "..."
      Height          =   255
      Left            =   2040
      TabIndex        =   10
      Top             =   1200
      Width           =   255
   End
   Begin VB.CommandButton cmdColMin 
      Caption         =   "..."
      Height          =   255
      Left            =   2040
      TabIndex        =   9
      Top             =   840
      Width           =   255
   End
   Begin VB.CommandButton cmdColHour 
      Caption         =   "..."
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   480
      Width           =   255
   End
   Begin VB.CommandButton cmdBG 
      Caption         =   "..."
      Height          =   255
      Left            =   4440
      TabIndex        =   7
      Top             =   120
      Width           =   255
   End
   Begin VB.TextBox txtBG 
      Height          =   285
      Left            =   1560
      TabIndex        =   6
      Top             =   120
      Width           =   2775
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Top             =   1680
      Width           =   1455
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   600
      TabIndex        =   0
      Top             =   1680
      Width           =   1455
   End
   Begin VB.Image imgBG 
      Height          =   1095
      Left            =   3240
      Stretch         =   -1  'True
      Top             =   480
      Width           =   1095
   End
   Begin VB.Shape shpColHour 
      FillColor       =   &H00FFFFFF&
      FillStyle       =   0  'Ausgefllt
      Height          =   255
      Left            =   1560
      Top             =   480
      Width           =   375
   End
   Begin VB.Shape shpColMin 
      FillColor       =   &H00FFFFFF&
      FillStyle       =   0  'Ausgefllt
      Height          =   255
      Left            =   1560
      Top             =   840
      Width           =   375
   End
   Begin VB.Shape shpColSec 
      BackColor       =   &H00FFFFFF&
      FillColor       =   &H00FFFFFF&
      FillStyle       =   0  'Ausgefllt
      Height          =   255
      Left            =   1560
      Top             =   1200
      Width           =   375
   End
   Begin VB.Label Label4 
      Caption         =   "Farbe Sekunden"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Farbe Minuten"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Farbe Stunden"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Hintergrundbild"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------
' Dieses Form enthlt die Elemente zur nderung der
' Eigenschaften der Uhr.

Option Explicit
Public OK As Boolean
Public colHour As Long
Public colMin As Long
Public colSec As Long
Public bgPath As String

' Event-Handler fr den Button zum ndern des Uhr-Hintergrunds
Private Sub cmdBG_Click()
    Dim Hintergrund As Picture
    
    ' Einstellen des Dateifilters
    comDialog.Filter = "*.jpg"
    
    ' Anzeigen des Datei-ffnen-Dialogs
    comDialog.ShowOpen
    
    ' Setzen des Pfades
    bgPath = comDialog.filename
    txtBG = bgPath
    
    ' Laden des neuen Hintergrunds
    Set Hintergrund = LoadPicture(bgPath)
    imgBG.Picture = Hintergrund
End Sub

' Event-Handler fr den Abbrechen-Button
Private Sub cmdCancel_Click()
    Unload Me
End Sub

' Event-Handler zum ndern der Farbe des Stundenzeigers
Private Sub cmdColHour_Click()
    comDialog.ShowColor
    colHour = comDialog.Color
    shpColHour.FillColor = colHour
End Sub

' Event-Handler zum ndern der Farbe des Minutenzeigers
Private Sub cmdColMin_Click()
    comDialog.ShowColor
    colMin = comDialog.Color
    shpColMin.FillColor = colMin
End Sub

' Event-Handler zum ndern der Farbe des Sekundenzeigers
Private Sub cmdColSec_Click()
    comDialog.ShowColor
    colSec = comDialog.Color
    shpColSec.FillColor = colSec
End Sub

' Event-Handler zum beenden des Dialogs
Private Sub cmdOK_Click()
    OK = True
    Unload Me
End Sub

' Initialisierung bei Laden des Formulars
Private Sub Form_Load()
    OK = False
    shpColHour.FillColor = colHour
    shpColMin.FillColor = colMin
    shpColSec.FillColor = colSec
    txtBG.text = bgPath
    imgBG.Picture = LoadPicture(bgPath)
End Sub
