VERSION 5.00
Begin VB.Form frmWuhr 
   ClientHeight    =   3000
   ClientLeft      =   165
   ClientTop       =   165
   ClientWidth     =   3030
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Icon            =   "frmWuhr.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Wuhr"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3000
   ScaleWidth      =   3030
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer Trigger 
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
   Begin VB.Menu mnuRoot 
      Caption         =   "Root"
      Visible         =   0   'False
      Begin VB.Menu mitMini 
         Caption         =   "Minimieren"
         Index           =   2
      End
      Begin VB.Menu mitClose 
         Caption         =   "Schlieen"
         Index           =   3
      End
      Begin VB.Menu Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mitProp 
         Caption         =   "Eigenschaften"
         Index           =   4
      End
   End
End
Attribute VB_Name = "frmWuhr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const Pi As Double = 3.1415926535

Private Hintergrund As Picture
Private Buffer As Picture
Private rBrush As Integer
Private rPen As Integer
Private hBrHour As Integer
Private hPenHour As Integer
Private hBrMin As Integer
Private hPenMin As Integer
Private hBrSec As Integer
Private hPenSec As Integer
Private xdiff As Long
Private ydiff As Long

Private Const MODULE_NAME As String = "frmWuhr"

Private nid As NotifyIconData

' Initialisieren beim ffnen des Formulars
Private Sub Form_Load()
10   On Error GoTo ErrorHandling

    ' hole die Eigenschaften aus der Registry
30  frmProperties.colHour = GetSetting("WUhr", "Layout", "HourColor", &HFFFFFF)
40  frmProperties.colMin = GetSetting("WUhr", "Layout", "MinuteColor", &HFFFFFF)
50  frmProperties.colSec = GetSetting("WUhr", "Layout", "SecondColor", &HFFFFFF)
60  frmProperties.bgPath = GetSetting("WUhr", "Layout", "Background", "clockbg5.bmp")
70  frmWuhr.Top = GetSetting("WUhr", "Layout", "Top", 0)
80  frmWuhr.Left = GetSetting("WUhr", "Layout", "Left", 0)
90  frmWuhr.Width = GetSetting("WUhr", "Layout", "Width", 200 * Screen.TwipsPerPixelX)
100 frmWuhr.Height = GetSetting("WUhr", "Layout", "Height", 200 * Screen.TwipsPerPixelY)
110 If frmWuhr.Top > Screen.Height - 20 Then frmWuhr.Top = 0
120 If frmWuhr.Left > Screen.Width - 20 Then frmWuhr.Left = 0
130 If frmWuhr.Width < 20 Then frmWuhr.Width = 20
140 If frmWuhr.Height < 20 Then frmWuhr.Height = 0
    
145 If frmProperties.bgPath = "" Then
150    frmProperties.bgPath = "clockbg1.bmp"
155 End If

    ' erzeugen der Brushes und Pens zum Zeichnen der Stunden-, Minuten-
    ' und Sekunden-Zeiger
160 hBrHour = CreateSolidBrush(frmProperties.colHour)
170 hPenHour = CreatePen(PS_SOLID, 1, frmProperties.colHour)
180 hBrMin = CreateSolidBrush(frmProperties.colMin)
190 hPenMin = CreatePen(PS_SOLID, 1, frmProperties.colMin)
200 hBrSec = CreateSolidBrush(frmProperties.colSec)
210 hPenSec = CreatePen(PS_SOLID, 1, frmProperties.colSec)

    ' Setzen des Hintergrund-Bildes der Uhr
230 Set Hintergrund = LoadPicture(frmProperties.bgPath)

    ' einfgen eines Icons in den SysTray
250 nid.cbSize = Len(nid)
260 nid.hWnd = frmWuhr.hWnd
270 nid.uId = vbNull
280 nid.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
290 nid.uCallBackMessage = WM_MOUSEMOVE
300 nid.hIcon = frmWuhr.Icon
310 nid.szTip = "Window Uhr" & vbNullChar
320 Shell_NotifyIcon NIM_ADD, nid

330 Exit Sub

900 ErrorHandling:
910     ErrorHandler "Form_Load"
End Sub

' Event-Handler beim drcken der Mouse-Buttons
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
10 On Error GoTo ErrorHandling

' Beim rechten Mouse-Button wird das Popup-Men gezeigt.
' Das Men wurde mit Extras->Men-Editor erstellt.
' Beim linken Mouse-Button wird die Position der Maus relativ zum Form gespeichert
20 If Button = vbRightButton Then
30      PopupMenu mnuRoot
40  ElseIf Button = vbLeftButton Then
50      xdiff = x
60      ydiff = y
70  End If
330 Exit Sub

900 ErrorHandling:
910     ErrorHandler "Form_MouseDown"
End Sub

' Event-Handler beim Bewegen der Maus.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
10   On Error GoTo ErrorHandling
    
20  Dim msg As Long
30  Dim result As Long
    
    ' Bei Bewegen mit linker Maustaste wird die Uhr verschoben
40  If Button = vbLeftButton Then
50      frmWuhr.Top = frmWuhr.Top + y - ydiff
60      frmWuhr.Left = frmWuhr.Left + x - xdiff

    ' Sonst kann es sich um einen Doppelklick im SysTray handeln.
    ' Die Uhr wird in den Vordergrund geholt.
70  Else
80      msg = x / Screen.TwipsPerPixelX
90      Select Case msg
        Case WM_LBUTTONDBLCLK
110         frmWuhr.Show
120         Call pSetForegroundWindow(Me.hWnd)
130     End Select
140 End If

150 Exit Sub

900 ErrorHandling:
910     ErrorHandler "Form_MouseMove"
End Sub

' Aktionen beim Beenden der Uhr
Private Sub Form_Unload(Cancel As Integer)
10  On Error GoTo ErrorHandling

    ' Lschen aller Brush- und Pen-Objekte
20  DeleteObject hBrHour
30  DeleteObject hPenHour
40  DeleteObject hBrMin
50  DeleteObject hPenMin
60  DeleteObject hBrSec
70  DeleteObject hPenSec
    
    ' Speichern der Gren- und Positions-Eigenschaften in der Registry
80  SaveSetting "WUhr", "Layout", "Top", frmWuhr.Top
90  SaveSetting "WUhr", "Layout", "Left", frmWuhr.Left
100 SaveSetting "WUhr", "Layout", "Width", frmWuhr.Width
110 SaveSetting "WUhr", "Layout", "Height", frmWuhr.Height
        
    ' Lschen des Icons aus dem SysTray
120 Shell_NotifyIcon NIM_DELETE, nid
    
130 Exit Sub

900 ErrorHandling:
910     ErrorHandler "Form_Unload"
End Sub

' Event-Handler fr Auswahl von "Beenden" aus dem Popup-Men
Private Sub mitClose_Click(Index As Integer)
10  On Error GoTo ErrorHandling
    
    ' Entladen des aktuellen Formulars
20  Unload frmWuhr
    
    Exit Sub

900 ErrorHandling:
910     ErrorHandler "mitClose_Click"
End Sub

' EVent-Handler fr Auswahl von "Minimieren" aus dem PopUp-Men
Private Sub mitMini_Click(Index As Integer)
10  On Error GoTo ErrorHandling

20  frmWuhr.Hide
    
30  Exit Sub

900 ErrorHandling:
910     ErrorHandler "mitMini_Click"
End Sub

'Private Sub mitMove_Click(Index As Integer)
'10  On Error GoTo ErrorHandling
'
'20  frmWuhr.Move 1000
'
'30  Exit Sub
'
'900 ErrorHandling:
'910     ErrorHandler "mitMove_Click"
'End Sub

' Event-Handler fr Auswahl von "Eigenschaften" aus dem PopUp-Men
Private Sub mitProp_Click(Index As Integer)
10  On Error GoTo ErrorHandling
    
    ' EInzeigen des Eigenschaften-Formulars
20  frmProperties.Show vbModal
    
    ' Speichern der genderten Werte der Eigenschaften fr
    ' Farben der Zeiger und Hintergrund der Uhr
30  SaveSetting "WUhr", "Layout", "HourColor", frmProperties.colHour
40  SaveSetting "WUhr", "Layout", "MinuteColor", frmProperties.colMin
50  SaveSetting "WUhr", "Layout", "SecondColor", frmProperties.colSec
60  SaveSetting "WUhr", "Layout", "Background", frmProperties.bgPath
    
    ' Lschen der alten Brush- und Pen-Objekte
70  DeleteObject hBrHour
80  DeleteObject hPenHour
90  DeleteObject hBrMin
100 DeleteObject hPenMin
110 DeleteObject hBrSec
120 DeleteObject hPenSec
    
    ' erzeugen der neuen Brush- und Pen-Objekte
130 hBrHour = CreateSolidBrush(frmProperties.colHour)
140 hPenHour = CreatePen(PS_SOLID, 1, frmProperties.colHour)
150 hBrMin = CreateSolidBrush(frmProperties.colMin)
160 hPenMin = CreatePen(PS_SOLID, 1, frmProperties.colMin)
170 hBrSec = CreateSolidBrush(frmProperties.colSec)
180 hPenSec = CreatePen(PS_SOLID, 1, frmProperties.colSec)
  
    ' Setzen des neuen Hintergrunds
190 Set Hintergrund = LoadPicture(frmProperties.bgPath)
    
200 Exit Sub

900 ErrorHandling:
910     ErrorHandler "mitProp_Click"
End Sub

' Zeichnen der Zeiger
Private Sub drawZeiger()
10  On Error GoTo ErrorHandling
    
20  Dim points(4) As gdiPoint
30  Dim tx As Integer
40  Dim ty As Integer
50  Dim sec As Integer
60  Dim min As Integer
70  Dim std As Integer
80  Dim w As Integer
90  Dim h As Integer
100 Dim x As Integer
110 Dim y As Integer
120 Dim hr As Long
    
    ' Interne Visual-Basic-Angaben sind immer in Twips. Das GDI arbeitet mit
    ' Pixels.Ein Pixel auf dem Bildschirm kann mehreren Twips entsprechen.
130 tx = Screen.TwipsPerPixelX
140 ty = Screen.TwipsPerPixelY
    
    ' berehnen der Hhe und Breite in Pixel
150 w = frmWuhr.Width / tx
160 h = frmWuhr.Height / ty
        
    ' berechnen der Stundenzeigerposition in sechzigstel Kreisumfang
170 std = (Hour(Time) Mod 12) * 5 + Minute(Time) / 12

    ' berechnen der Punkte zum Zeichnen des Stundenzeiger-Polygons
180 points(0).x = w / 2
190 points(0).y = h / 2
200 points(1).x = w / 2 + Sin(2 * Pi * std / 60 - 0.15) * (w / 6) / 2
210 points(1).y = h / 2 - Cos(2 * Pi * std / 60 - 0.15) * (h / 6) / 2
220 points(2).x = w / 2 + Sin(2 * Pi * std / 60) * (w / 1.7) / 2
230 points(2).y = h / 2 - Cos(2 * Pi * std / 60) * (h / 1.7) / 2
240 points(3).x = w / 2 + Sin(2 * Pi * std / 60 + 0.15) * (w / 6) / 2
250 points(3).y = h / 2 - Cos(2 * Pi * std / 60 + 0.15) * (h / 6) / 2

    ' setzen des Brush und des Pen-Objekts fr den Stundenzeiger
260 hr = SelectObject(frmWuhr.hDC, hBrHour)
270 hr = SelectObject(frmWuhr.hDC, hPenHour)

    ' zeichnen des Stundenzeiger-Polygons
280 Polygon frmWuhr.hDC, points(0), 4
    
    ' berechnen der minutenzeiger-Position in sechzigstel Kreisumfang
290 min = Minute(Time)
    
    ' berechnen der Punkte zum Zeichnen des Minutenzeiger-Polygons
300 points(0).x = w / 2
310 points(0).y = h / 2
320 points(1).x = w / 2 + Sin(2 * Pi * min / 60 - 0.09) * (w / 6) / 2
330 points(1).y = h / 2 - Cos(2 * Pi * min / 60 - 0.09) * (h / 6) / 2
340 points(2).x = w / 2 + Sin(2 * Pi * min / 60) * (w / 1.3) / 2
350 points(2).y = h / 2 - Cos(2 * Pi * min / 60) * (h / 1.3) / 2
360 points(3).x = w / 2 + Sin(2 * Pi * min / 60 + 0.09) * (w / 6) / 2
370 points(3).y = h / 2 - Cos(2 * Pi * min / 60 + 0.09) * (h / 6) / 2

    ' setzen des Brush und des Pen-Objekts fr den Minutenzeiger
380 hr = SelectObject(frmWuhr.hDC, hBrMin)
390 hr = SelectObject(frmWuhr.hDC, hPenMin)

    ' zeichnen des Minutenzeiger-Polygons
400 Polygon frmWuhr.hDC, points(0), 4
    
    ' berechnen der Sekundenzeiger-Position in sechzigstel Kreisumfang
410 sec = Second(Time)

    ' berechnen der Punkte zum Zeichnen des Sekundenzeiger-Polygons
420 x = w / 2 + Sin(2 * Pi * sec / 60) * w / 2.5
430 y = h / 2 - Cos(2 * Pi * sec / 60) * h / 2.5
440 points(0).x = w / 2 + Sin(2 * Pi * sec / 60) * w / 2.5
450 points(0).y = h / 2 - Cos(2 * Pi * sec / 60) * h / 2.5
460 points(1).x = w / 2
470 points(1).y = h / 2
480 points(2).x = w / 2
490 points(2).y = h / 2

    ' setzen des Brush und des Pen-Objekts fr den Sekundenzeiger
500 hr = SelectObject(frmWuhr.hDC, hBrSec)
510 hr = SelectObject(frmWuhr.hDC, hPenSec)

    ' zeichnen des Sekundenzeiger-Polygons
520 Polygon frmWuhr.hDC, points(0), 3
    
530 Exit Sub
     
900 ErrorHandling:
910     ErrorHandler "drawZeiger"
End Sub

' Timer-Routine fr die Aktualisierung der Uhr
Private Sub Trigger_Timer()
10  On Error GoTo ErrorHandling
    
20  Dim sec As Integer
30  Dim x As Integer
40  Dim y As Integer
50  Dim w As Integer
60  Dim h As Integer

    ' setzen des Hintergrunds, wenn sein Laden erfolgreich war
65  If Hintergrund <> 0 Then
70      frmWuhr.PaintPicture Hintergrund, 0, 0, frmWuhr.ScaleWidth, frmWuhr.ScaleHeight
75  End If

    ' zeichnen der Zeiger
80  drawZeiger
    
90  Exit Sub

900 ErrorHandling:
910     ErrorHandler "Trigger_Timer"
920     End
End Sub

' Fehlerbehandlung mit Anzeige des Fehlers, des Funktionsnamens und der
' Zeilennummer
Private Sub ErrorHandler(functionName As String)
10  MsgBox Str$(Err.Number) & ": " & Err.Description & vbCrLf & _
        " in " & MODULE_NAME & "." & functionName & " bei Zeile " & Str$(Erl)
End Sub
