Attribute VB_Name = "gdi32"
'----------------------------------------------------------
'
' Diese Datei definiert Typen, Konstanten und Funktionen der
' Library gdi32.dll . Die Definitionen knnen mit dem
' API-Katalog aus der Datei Programme\DevStudio\VB\Win32Api.txt
' eingefgt werden.
' Voraussetzung ist die Installation von "Online-Hilfe und
' Beispielapplikationen / Windows-Api-Referenz" aus der
' Visual-Basic-Installation.

Type gdiPoint
    x As Long
    y As Long
End Type
     
Public Const PS_SOLID As Integer = &H0

Declare Function CreateFont% Lib "gdi32" (ByVal h%, ByVal w%, ByVal e%, _
    ByVal o%, ByVal n%, ByVal i%, ByVal u%, ByVal s%, ByVal c%, _
    ByVal op%, ByVal cp%, ByVal q%, ByVal j%, ByVal f$)
    
'Declare Function CreateFontIndirect Lib "gdi32" (lpLogFont As LogFont) _
'    As Integer
        
Declare Function TextOut Lib "gdi32" (ByVal hDC%, ByVal x%, ByVal y%, _
    ByVal text$, ByVal nCount%) As Integer
    
Declare Function GetDeviceCaps Lib "gdi32" Alias "getdevicecaps" (ByVal hDC%, ByVal _
    nIndex%) As Integer
    
Declare Function GetTextFace Lib "gdi32" (ByVal hDC As Integer, _
    ByVal nCount As Integer, ByVal lpname As String) As Integer
    
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Integer, _
    ByVal nWidth As Integer, ByVal crColor As Long) As Integer

Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) _
         As Integer
    
Declare Function SelectObject Lib "gdi32" (ByVal hDC As Integer, _
    ByVal hObject As Integer) As Integer

Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Integer) _
    As Integer
        
Declare Function MoveTo Lib "gdi32" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Long

Declare Function LineTo Lib "gdi32" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
    
Declare Function Rectangle Lib "gdi32" (ByVal hDC%, ByVal Left%, _
    ByVal Top%, ByVal Right%, ByVal Bottom%) As Integer

Declare Function FillRect Lib "gdi32" (ByVal hDC%, ByVal Left%, _
    ByVal Top%, ByVal Right%, ByVal Bottom%) As Integer

Declare Function Polygon Lib "gdi32" (ByVal hDC As Integer, _
    lpPoints As gdiPoint, ByVal nCount As Integer) As Integer
